from typing import Iterable, Tuple

from aiohttp.web_app import Application
from aiohttp.web_routedef import AbstractRouteDef
from aiohttp.typedefs import Middleware


def create_app(
    routes: Iterable[AbstractRouteDef],
    sub_apps: Iterable[Tuple[str, Application]] = (),
    middlewares: Iterable[Middleware] = (),
):
    app = Application(middlewares=middlewares)
    app.add_routes(routes)
    for prefix, sub_app in sub_apps:
        app.add_subapp(prefix, sub_app)
    return app
